########################################################################
# Brake distance by Ray Krebs
# 
# Version:	1.0
# Date:		30.09.2016
########################################################################

import ac, acsys, sys, math

########################################################################
# adjust the size of the app, for example, scale = 1.0, scale = 1.5 ...
#
scale = 1.0
#
########################################################################




########################################################################
# global vars
#
appWindow=0
count=0
vmax=0
timeBase=0
FontSize=14	# Size ot fhe font
brakeAktive=0	# Flag if brake was triggerd
distance=0	# Total driven distance
distance100=0	# Brake distance from 100km/h to 0
distance150=0	# Brake distance from 150km/h to 0
distance200=0	# Brake distance from 200km/h to 0
distance250=0	# Brake distance from 250km/h to 0

########################################################################
# This function gets called by AC when the Plugin is initialised
# The function has to return a string with the plugin name
#
def acMain(ac_version):
   global speedLabel, brakeLabel, distanceLabel, Label, distance100Label, distance150Label, distance200Label
   global distance250Label, timeLabel

   appWindow = ac.newApp("Brake distance")
   ac.setSize(appWindow, 300*scale, 300*scale)
   
   # Speed
   speedLabel = ac.addLabel(appWindow, "Speed:")
   # Position (Label, x-Pos, y-Pos)
   ac.setPosition(speedLabel, 5, 40*scale)
   ac.setFontSize(speedLabel, FontSize*scale)

   # Brake
   brakeLabel = ac.addLabel(appWindow, "Brake Level:")
   # Position (Label, x-Pos, y-Pos)
   ac.setPosition(brakeLabel, 5, 65*scale)
   ac.setFontSize(brakeLabel, FontSize*scale)

   # Distance
   distanceLabel = ac.addLabel(appWindow, "Total Distance:")
   # Position (Label, x-Pos, y-Pos)
   ac.setPosition(distanceLabel, 5, 90*scale)
   ac.setFontSize(distanceLabel, FontSize*scale)

   # Brake distance from 250 km/h to 0
   distance250Label = ac.addLabel(appWindow, "Brake distance 250km/h to 0:")
   # Position (Label, x-Pos, y-Pos)
   ac.setPosition(distance250Label, 5, 140*scale)
   ac.setFontSize(distance250Label, FontSize*scale)

   # Brake distance from 200 km/h to 0
   distance200Label = ac.addLabel(appWindow, "Brake distance 200km/h to 0:")
   # Position (Label, x-Pos, y-Pos)
   ac.setPosition(distance200Label, 5, 165*scale)
   ac.setFontSize(distance200Label, FontSize*scale)
    
   # Brake distance from 150 km/h to 0
   distance150Label = ac.addLabel(appWindow, "Brake distance 150km/h to 0:")
   # Position (Label, x-Pos, y-Pos)
   ac.setPosition(distance150Label, 5, 190*scale)
   ac.setFontSize(distance150Label, FontSize*scale)

   # Brake distance from 100 km/h to 0
   distance100Label = ac.addLabel(appWindow, "Brake distance 100km/h to 0:")
   # Position (Label, x-Pos, y-Pos)
   ac.setPosition(distance100Label, 5, 215*scale)
   ac.setFontSize(distance100Label, FontSize*scale)

   # Time Label
   timeLabel = ac.addLabel(appWindow, "Time:")
   # Position (Label, x-Pos, y-Pos)
   ac.setPosition(timeLabel, 5, 240*scale)
   ac.setFontSize(timeLabel, FontSize*scale)

   ac.addRenderCallback(appWindow, onFormRender) 
   return "Brake distance"

########################################################################
# This function gets called every x-ms
#
def onFormRender(deltaT):
   global speedLabel, brakeLabel, distanceLabel, distance100Label, distance150Label, distance200Label, distance250Label, timeLabel, timeBase
   global OldXValue, OldYValue, OldZValue, count, distance, vmax, distance100, distance150, distance200, distance250, brakeAktive

   # Get actual speed and save Vmax
   speedValueKMH = ac.getCarState(0, acsys.CS.SpeedKMH)
   if vmax < speedValueKMH:
      vmax = speedValueKMH

   # Display actual speed and Vmax
   ac.setText(speedLabel, "Speed: {:.0f} km/h                   Vmax: {:.0f} km/h".format(speedValueKMH,vmax))

   #Get actual Gas value
   gasValue = ac.getCarState(0, acsys.CS.Gas)

   # Get actual brake value
   brakeValue = ac.getCarState(0, acsys.CS.Brake)

   # Display actual brake value
   ac.setText(brakeLabel, "Brake Level: {:.2f}".format(brakeValue))
   if brakeValue != 0:
      brakeAktive=1

   # get the Vector of the world position and direction
   if count==0:
      OldXValue, OldYValue, OldZValue = ac.getCarState(0, acsys.CS.WorldPosition)
      count=1
   else:
      x, y, z = ac.getCarState(0, acsys.CS.WorldPosition)
      dx=x-OldXValue
      dy=y-OldYValue
      dz=z-OldZValue
      OldXValue=x
      OldYValue=y      
      OldZValue=z
      deltaQ=dx*dx+dy*dy+dz*dz
      delta=math.sqrt(deltaQ)
      distance=distance+delta
      count=count+1

   # Display total driven distance
   ac.setText(distanceLabel, "Total Distance: {:.2f} m".format(distance))

   # calculate distance 250 to 0 
   if brakeAktive==1 and speedValueKMH < 250 and vmax > 250:
      distance250=distance250+delta

   # Display brake the distance 250 to 0 
   ac.setText(distance250Label, "Brake distance 250km/h to 0: {:.2f} m".format(distance250))

   # calculate distance 200 to 0 
   if brakeAktive==1 and speedValueKMH < 200 and vmax > 200:
      distance200=distance200+delta

   # Display brake the distance 200 to 0 
   ac.setText(distance200Label, "Brake distance 200km/h to 0: {:.2f} m".format(distance200))

   # calculate distance 150 to 0 
   if brakeAktive==1 and speedValueKMH < 150 and vmax > 150:
      distance150=distance150+delta

   # Display brake the distance 150 to 0 
   ac.setText(distance150Label, "Brake distance 150km/h to 0: {:.2f} m".format(distance150))

   # calculate distance 100 to 0   
   if brakeAktive==1 and speedValueKMH < 100 and vmax > 100:
      distance100=distance100+delta

   # Display brake the distance 100 to 0
   ac.setText(distance100Label, "Brake distance 100km/h to 0: {:.2f} m".format(distance100))

   # Time Label
   timeBase=timeBase+deltaT
   # timeBase+deltaT
   ac.setText(timeLabel, "Time: {:.3f} s".format(timeBase))

   # Hold the distance when speed < 0.01
   if speedValueKMH < 0.01:
      brakeAktive=0

   # Reset brake values
   if brakeValue == 0 and speedValueKMH > 50 and gasValue > 0.2:
      vmax=0
      #count=0
      #distance=0
      distance100=0
      distance150=0
      distance200=0
      distance250=0

